<template lang="pug">
	#visor(:style="estilo")
		.contenedor(:style="estiloContenedor", ref="contenedor")
			component.elemento(
				v-for="objeto in pagina.objetos"
				:key="objeto.id"
				:id="objeto.id"
				:is="objeto.tag"
				v-bind="objeto.atributos"
				v-text="objeto.texto||null"
				:style="objeto.estilo")

</template>

<script>
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex'
import { toPng, toJpeg, toBlob, toPixelData, toSvg } from 'html-to-image'

export default {
	data(){
		return {
		}
	},
	computed:{
		estilo(){
			return {
				width: `${this.ancho}px`,
				height: `${this.alto}px`,
				padding: `${this.margen}px`,
				transform: `scale(${this.zoom})`
			}
		},
		estiloContenedor(){
			return {
				background: this.pagina.fondo,
				// margin: `${this.margen}px`
			}
		},

		...mapState({
			margen: state => state.opciones.margen,
			modo: state => state.editor.modo,
			zoom: state => state.editor.zoom,
		}),
		...mapGetters({
			pagina : "contenido/actual",
			ancho : "editor/ancho",
			alto : "editor/alto",
			elemento: "editor/actual"
			// margen : "opciones/margen",
		})
	},
	methods:{
		seleccionar(punto){
			// console.debug(punto)
			const elemento = this.seleccionarElementoPorPunto(punto.x, punto.y)
			// const elementos = this.elementsFromPoint(punto.x, punto.y)
			// console.debug(elemento)
			if (elemento) {
				// console.debug(elemento.getBoundingClientRect())
				// this.establecerActual(elemento.id)
				// this.establecerSeleccion(elemento.id)
				// console.debug(this.elemento)
				this.seleccionarElemento(elemento)
			}
		},
		elementsFromPoint(x,y) {
			var elements = [], previousPointerEvents = [], current, i, d;

						// get all elements via elementFromPoint, and remove them from hit-testing in order
			while ((current = document.elementFromPoint(x,y)) && elements.indexOf(current)===-1 && current != null) {
				elements.push(current);
				previousPointerEvents.push({
						value: current.style.getPropertyValue('pointer-events'),
						priority: current.style.getPropertyPriority('pointer-events')
				});

				// add "pointer-events: none", to get to the underlying element
				current.style.setProperty('pointer-events', 'none', 'important');
			}

						// restore the previous pointer-events values
			for(i = previousPointerEvents.length; d=previousPointerEvents[--i]; ) {
				elements[i].style.setProperty('pointer-events', d.value?d.value:'', d.priority);
			}

			// return our results
			return elements;
		},
		seleccionarElementoPorPunto(x, y){
			let elementos= [],
				previos = [],
				actual, i, d

				while (
					(actual = document.elementFromPoint(x,y))
						&& elementos.indexOf(actual)===-1
						&& actual != null
						&& !actual.className.toString().includes("elemento")
					) {
					elementos.push(actual)
					previos.push({
						valor: actual.style.getPropertyValue('pointer-events'),
						prioridad: actual.style.getPropertyPriority('pointer-events')
					})

					actual.style.setProperty('pointer-events', 'none', 'important')
				}

				for(i = previos.length; d=previos[--i]; ) {
					elementos[i].style.setProperty('pointer-events', d.valor || '', d.prioridad);
				}

				return actual.className.toString().includes("elemento") ? actual : null
		},
		...mapMutations({
			establecerContenedor: "editor/establecerContenedor",
			// establecerActual: "editor/elementoActual",
			actualizarPrevio: "contenido/actualizarPrevio",
		}),
		...mapActions({
			seleccionarElemento: "editor/seleccionarElemento"
		})
	},
	mounted(){
		// svg.uno("assslgo");
		// console.debug(this.$store);
		// console.debug("this.ancho");
		// console.debug(this.ancho);
		// console.debug(this);
		this.establecerContenedor(this.$refs.contenedor)

		const acciones = [
			"editor/actualizarPrevio",
		]

		// this.$store.subscribeAction((action, state) => {
		// 		console.debug("subscribeAction", action.type)
		// 	if (acciones.includes(action.type)) {
		// 		console.debug("actualizarPrevio", this)

		// 		toJpeg(this.$refs.contenedor)
		// 			.then(function (dataUrl) {
		// 				// console.debug(dataUrl)
		// 				this.actualizarPrevio(dataUrl)
		// 			});
		// 	}
		// })

		this.$store.subscribeAction({
			before: (action, state) => {
				switch (action.type){
					case "editor/guardarContenido":
						// toJpeg(this.$refs.contenedor)
						// .then(function (dataUrl) {
						// 	// console.debug(dataUrl)
						// 	this.actualizarPrevio(dataUrl)
						// })
					break;
				}
			},
			after: (action, state) => {
				if (acciones.includes(action.type)) {
					// console.debug("actualizarPrevio", this)

					// toJpeg(this.$refs.contenedor)
					// 	.then(function (dataUrl) {
					// 		// console.debug(dataUrl)
					// 		this.actualizarPrevio(dataUrl)
					// 	})
				}
			}
		})
	}
}
</script>

<style lang="stylus" scoped>
#visor
	width 100%
	height 100%
	overflow visible
	// box-sizing content-box
	transition all 150ms ease-in-out
	// outline 1px solid blue

	// overflow hidden

	.contenedor
		position relative
		width 100%
		height 100%
		overflow hidden
		box-shadow 0 0 16px black
		transition all 150ms ease-in-out

		img
			position absolute
			margin 0
			object-fit cover
			object-position top left

		p
			position absolute
			margin 0
			padding 0

		div
			position absolute
			margin 0
			padding 0


</style>
